/* USER CODE BEGIN Header */
/**
  **************************************************ca**********************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "string.h"
#include "string.h"
#include "stdio.h"
#include "stdlib.h"
#include "math.h"
#include "i2c-lcd.h"
#include "mpu6050.h"
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
#define AT45DB_WRBF1         0x84 /* Buffer 1 Write */
#define AT45DB_SR_RDY       (1 << 7) /* Bit 7: RDY/ Not BUSY */
#define AT45DB_RDSR          0xd7 /* Status Register Read */
#define AT45DB_RDBF1         0xd4 /* Buffer 1 Read */
#define AT45DB_BF1TOMNE      0x83 /* Buffer 1 to Main Memory Page Program with Built-in Erase */
#define AT45DB_MNTOBF1XFR    0x53 /* Main Memory Page to Buffer 1 Transfer */
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */


/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
ADC_HandleTypeDef hadc1;

I2C_HandleTypeDef hi2c1;
I2C_HandleTypeDef hi2c2;

SPI_HandleTypeDef hspi1;

UART_HandleTypeDef huart1;
DMA_HandleTypeDef hdma_usart1_rx;

/* USER CODE BEGIN PV */


/*********************************************/
HAL_StatusTypeDef result;

volatile uint8_t rx_len=0;
volatile uint8_t recv_end_flag=0;
uint8_t rx_buffer[150] ="\0";//Cache array
char *str = {0};
uint8_t SendCommand[20],Data[512];

char strlong[6];
char telefone[14];
char mensagem[60];
int hours,minutes,secounds,minutetwo = 0;
char UTCdatetime[19];

double distcar = 0.00;

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_DMA_Init(void);
static void MX_I2C1_Init(void);
static void MX_SPI1_Init(void);
static void MX_USART1_UART_Init(void);
static void MX_ADC1_Init(void);
static void MX_I2C2_Init(void);
/* USER CODE BEGIN PFP */
void AT45DB_CS_Set(void);
void AT45DB_CS_Reset(void);
void at45db_active(void);
void at45db_deactive(void);
void AT45DB_Init(void);
uint8_t at45db_waitbusy(void);
void FlashBuffer1Write(uint16_t start_addr, uint16_t len, uint8_t *buffer);
uint8_t at45db_rdsr(void);
void FlashBuffer1Read(uint16_t start_addr, uint16_t len, uint8_t *buffer);
void FlashBuffer1ProgAutoErase(uint16_t star_addr);
void PageToBuffer1(uint16_t star_addr);

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
void at45db_active(void)
{
	HAL_GPIO_WritePin(EEPROM_CS_GPIO_Port, EEPROM_CS_Pin, GPIO_PIN_RESET);
}

void at45db_deactive(void)
{
	HAL_GPIO_WritePin(EEPROM_CS_GPIO_Port, EEPROM_CS_Pin, GPIO_PIN_SET);
}

void AT45DB_CS_Set(void)
{
	HAL_GPIO_WritePin(EEPROM_CS_GPIO_Port, EEPROM_CS_Pin, GPIO_PIN_RESET);

}

void AT45DB_CS_Reset(void)
{
HAL_GPIO_WritePin(EEPROM_CS_GPIO_Port, EEPROM_CS_Pin, GPIO_PIN_SET);
}

void AT45DB_Init(void)
{

}
uint8_t at45db_waitbusy(void)
{
    uint8_t sr;

    /* Poll the device, waiting for it to report that it is ready */

    do
    {
        HAL_Delay(10);
        sr = (uint8_t)at45db_rdsr();
				printf(".");
    }
    while ((sr & AT45DB_SR_RDY) == 0);

    return sr;
}

uint8_t at45db_rdsr(void)
{
	HAL_StatusTypeDef res;
	uint8_t cmd[1] = {0, };
	uint8_t status[1] = {0, };

	at45db_active();

	cmd[0] = AT45DB_RDSR;
	res = HAL_SPI_Transmit(&hspi1, cmd, sizeof(cmd), HAL_MAX_DELAY);
	if (res != HAL_OK)
		printf("HAL_SPI_Transmit Error\r\n");

	res = HAL_SPI_Receive(&hspi1, status, sizeof(status), HAL_MAX_DELAY);
	if (res != HAL_OK)
		printf("HAL_SPI_Receive Error\r\n");

	at45db_deactive();

    return status[0];
}


void FlashBuffer1Write(uint16_t start_addr, uint16_t len, uint8_t *buffer)
{
    HAL_StatusTypeDef res;
    uint8_t cmd[4] = {0, };

    printf("FlashBuffer1Write Start\r\n");

#ifdef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    at45db_active();

    cmd[0] = AT45DB_WRBF1;
    cmd[1] = 0x00;
    cmd[2] = (uint8_t)(start_addr>>8);
    cmd[3] = (uint8_t)(start_addr);

    res = HAL_SPI_Transmit(&hspi1, cmd, sizeof(cmd), HAL_MAX_DELAY);
    if (res != HAL_OK)
        printf("HAL_SPI_Transmit Error\r\n");

    res = HAL_SPI_Transmit(&hspi1, buffer, len, HAL_MAX_DELAY);
    if (res != HAL_OK)
        printf("HAL_SPI_Transmit Error\r\n");

    at45db_deactive();

#ifndef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    printf("FlashBuffer1Write End\r\n");
}

void FlashBuffer1Read(uint16_t start_addr, uint16_t len, uint8_t *buffer)
{
    HAL_StatusTypeDef res;
    uint8_t cmd[5] = {0, };

    printf("FlashBuffer1Read Start\r\n");

#ifdef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    at45db_active();

    cmd[0] = AT45DB_RDBF1;
    cmd[1] = 0x00;
    cmd[2] = (uint8_t)(start_addr>>8);
    cmd[3] = (uint8_t)(start_addr);
		cmd[4] = 0x00;  // Additional Don't Care Bytes
    res = HAL_SPI_Transmit(&hspi1, cmd, sizeof(cmd), HAL_MAX_DELAY);
    if (res != HAL_OK)
        printf("HAL_SPI_Transmit Error\r\n");

    res = HAL_SPI_Receive(&hspi1, buffer, len, HAL_MAX_DELAY);
    if (res != HAL_OK)
        printf("HAL_SPI_Receive Error\r\n");

    at45db_deactive();

#ifndef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    printf("FlashBuffer1Read End\r\n");
}

void FlashBuffer1ProgAutoErase(uint16_t star_addr)
{
    HAL_StatusTypeDef res;
    uint8_t cmd[4] = {0, };

    printf("FlashBuffer1ProgAutoErase Start\r\n");

#ifdef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    at45db_active();

    cmd[0] = AT45DB_BF1TOMNE;
    cmd[1] = (uint8_t)(star_addr>>8);
    cmd[2] = (uint8_t)(star_addr);
    cmd[3] = 0x00;

    res = HAL_SPI_Transmit(&hspi1, cmd, sizeof(cmd), HAL_MAX_DELAY);
    if (res != HAL_OK)
    	printf("HAL_SPI_Transmit Error\r\n");

    at45db_deactive();

#ifndef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    printf("FlashBuffer1ProgAutoErase End\r\n");
}

void PageToBuffer1(uint16_t star_addr)
{
    HAL_StatusTypeDef res;
    uint8_t cmd[4] = {0, };

    printf("PageToBuffer1 Start\r\n");

#ifdef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    at45db_active();

    cmd[0] = AT45DB_MNTOBF1XFR;
    cmd[1] = (uint8_t)(star_addr>>7);
    cmd[2] = (uint8_t)(star_addr<<1);
    cmd[3] = 0x00;

    res = HAL_SPI_Transmit(&hspi1, cmd, sizeof(cmd), HAL_MAX_DELAY);
    if (res != HAL_OK)
        printf("HAL_SPI_Transmit Error\r\n");

    at45db_deactive();

#ifndef CONFIG_AT45DB_PREWAIT
    at45db_waitbusy();
#endif

    printf("PageToBuffer1 End\r\n");
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_DMA_Init();
  MX_I2C1_Init();
  MX_SPI1_Init();
  MX_USART1_UART_Init();
  MX_ADC1_Init();
  MX_I2C2_Init();
  /* USER CODE BEGIN 2 */
  AT45DB_Init();
  printf("a iniciar\r\n");

uint8_t escrita[10] = "ola mundo";
 FlashBuffer1Write(0x01,10,escrita);
 HAL_Delay(100);

FlashBuffer1ProgAutoErase(0x01);
	HAL_Delay(100);

uint8_t  leitura[10]={0};
FlashBuffer1Read(0x01, 10, leitura);
printf(" Buffer lido=: %s\r\n", leitura);



printf("fim\r\n");


  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
	while (1)
	{


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */
  }
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};
  RCC_PeriphCLKInitTypeDef PeriphClkInit = {0};

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSE;
  RCC_OscInitStruct.HSEState = RCC_HSE_ON;
  RCC_OscInitStruct.HSEPredivValue = RCC_HSE_PREDIV_DIV1;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSE;
  RCC_OscInitStruct.PLL.PLLMUL = RCC_PLL_MUL9;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }
  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
  PeriphClkInit.PeriphClockSelection = RCC_PERIPHCLK_ADC;
  PeriphClkInit.AdcClockSelection = RCC_ADCPCLK2_DIV6;
  if (HAL_RCCEx_PeriphCLKConfig(&PeriphClkInit) != HAL_OK)
  {
    Error_Handler();
  }
  /** Enables the Clock Security System
  */
  HAL_RCC_EnableCSS();
}

/**
  * @brief ADC1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_ADC1_Init(void)
{

  /* USER CODE BEGIN ADC1_Init 0 */

  /* USER CODE END ADC1_Init 0 */

  ADC_ChannelConfTypeDef sConfig = {0};

  /* USER CODE BEGIN ADC1_Init 1 */

  /* USER CODE END ADC1_Init 1 */
  /** Common config
  */
  hadc1.Instance = ADC1;
  hadc1.Init.ScanConvMode = ADC_SCAN_DISABLE;
  hadc1.Init.ContinuousConvMode = DISABLE;
  hadc1.Init.DiscontinuousConvMode = DISABLE;
  hadc1.Init.ExternalTrigConv = ADC_SOFTWARE_START;
  hadc1.Init.DataAlign = ADC_DATAALIGN_RIGHT;
  hadc1.Init.NbrOfConversion = 1;
  if (HAL_ADC_Init(&hadc1) != HAL_OK)
  {
    Error_Handler();
  }
  /** Configure Regular Channel
  */
  sConfig.Channel = ADC_CHANNEL_1;
  sConfig.Rank = ADC_REGULAR_RANK_1;
  sConfig.SamplingTime = ADC_SAMPLETIME_1CYCLE_5;
  if (HAL_ADC_ConfigChannel(&hadc1, &sConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN ADC1_Init 2 */

  /* USER CODE END ADC1_Init 2 */

}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.ClockSpeed = 100000;
  hi2c1.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief I2C2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C2_Init(void)
{

  /* USER CODE BEGIN I2C2_Init 0 */

  /* USER CODE END I2C2_Init 0 */

  /* USER CODE BEGIN I2C2_Init 1 */

  /* USER CODE END I2C2_Init 1 */
  hi2c2.Instance = I2C2;
  hi2c2.Init.ClockSpeed = 100000;
  hi2c2.Init.DutyCycle = I2C_DUTYCYCLE_2;
  hi2c2.Init.OwnAddress1 = 0;
  hi2c2.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c2.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c2.Init.OwnAddress2 = 0;
  hi2c2.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c2.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C2_Init 2 */

  /* USER CODE END I2C2_Init 2 */

}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_4;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief USART1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART1_UART_Init(void)
{

  /* USER CODE BEGIN USART1_Init 0 */

  /* USER CODE END USART1_Init 0 */

  /* USER CODE BEGIN USART1_Init 1 */

  /* USER CODE END USART1_Init 1 */
  huart1.Instance = USART1;
  huart1.Init.BaudRate = 115200;
  huart1.Init.WordLength = UART_WORDLENGTH_8B;
  huart1.Init.StopBits = UART_STOPBITS_1;
  huart1.Init.Parity = UART_PARITY_NONE;
  huart1.Init.Mode = UART_MODE_TX_RX;
  huart1.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart1.Init.OverSampling = UART_OVERSAMPLING_16;
  if (HAL_UART_Init(&huart1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART1_Init 2 */

  /* USER CODE END USART1_Init 2 */

}

/**
  * Enable DMA controller clock
  */
static void MX_DMA_Init(void)
{

  /* DMA controller clock enable */
  __HAL_RCC_DMA1_CLK_ENABLE();

  /* DMA interrupt init */
  /* DMA1_Channel5_IRQn interrupt configuration */
  HAL_NVIC_SetPriority(DMA1_Channel5_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(DMA1_Channel5_IRQn);

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOD_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, EEPROM_CS_Pin|GSM_RI_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, EEPROM_WP_Pin|GPIO_PIN_1|OUT_3_Pin|OUT_2_Pin
                          |GSM_DTR_Pin|GSM_POWER_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pins : INPUT_RESERVA_Pin INPUT_KEY_Pin INPUT_SHOCK_Pin */
  GPIO_InitStruct.Pin = INPUT_RESERVA_Pin|INPUT_KEY_Pin|INPUT_SHOCK_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_INPUT;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : EEPROM_CS_Pin GSM_RI_Pin */
  GPIO_InitStruct.Pin = EEPROM_CS_Pin|GSM_RI_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : EEPROM_WP_Pin PB1 OUT_3_Pin OUT_2_Pin
                           GSM_DTR_Pin GSM_POWER_Pin */
  GPIO_InitStruct.Pin = EEPROM_WP_Pin|GPIO_PIN_1|OUT_3_Pin|OUT_2_Pin
                          |GSM_DTR_Pin|GSM_POWER_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
